program soundex;
const
     space9 = '         ';
     space19= '                   ';
var
   infile, outfile: text;
   name: string[20];
   code: string[4];

function letter_code(c:char):char;
   begin
      case c of
         'A','E','I','O','U','Y','W','H': letter_code := '0';
         'B','P','F','V':                 letter_code := '1';
         'C','S','K','G','J','Q','X','Z': letter_code := '2';
         'D','T':                         letter_code := '3';
         'L':                             letter_code := '4';
         'M','N':                         letter_code := '5';
         'R':                             letter_code := '6';
         else                             letter_code := ' ';
      end;
   end;

function soundex_code(s:string):string;
   const
       MAX_CODE_LEN = 4;
   var i: integer;
       last_code, code : char;
       code_len : integer;
       t: string;
   begin
      t := '';
      t := t + s[1];
      last_code := letter_code(s[1]);
      code_len := 1;
      i := 2;
      while (i <= length(s)) and (code_len < MAX_CODE_LEN) do begin
         code := letter_code(s[i]);
         if (code <> last_code) and (code <> '0') and (code <> ' ') then begin
            t := t + code;
            code_len := code_len + 1;
         end;
         i := i + 1;
         if code <> ' ' then last_code := code;
      end;
      while code_len < MAX_CODE_LEN do begin
         t := t + '0';
         code_len := code_len + 1;
      end;
      soundex_code := t;
   end;

function left_justify(s:string; width:integer):string;
   var
      i : integer;
      t : string;
   begin
      t := '';
      i := 1;
      while (i <= length(s)) and (i <= width) do begin
         t := t + s[i];
         i := i + 1;
      end;
      while i <= width do begin
         t := t + ' ';
         i := i + 1;
      end;
      left_justify  := t;
   end;

begin
   assign(infile,'soundex.in');
   assign(outfile,'soundex.out');
   reset (infile);
   rewrite(outfile);
   writeln(outfile,space9,left_justify('NAME',25),'SOUNDEX CODE');
   while not eof(infile) do begin
      readln(infile,name);
      code := soundex_code(name);
      writeln(outfile,space9,left_justify(name,25),code);
   end;
   writeln(outfile,space19,'END OF OUTPUT');
   close (infile);
   close(outfile);
end.
