program LostInSpace( input, output, InputFile, OutputFile );

type
  Directions = (n, ne, e, se, s, sw, w, nw);

var
  SquareSize : integer;
  Space : array[0..50, 0..50] of char;
  SearchString : string[50];
  InputFile : text;
  OutputFile : text;
  Row, Col : integer;
  Direction : Directions;
  Found, CheckResult : Boolean;

procedure Check(rw, cl: integer;
               dir : Directions;
               var Match : Boolean);
var
  i : integer;
  DirStr : string[5];

procedure move;
begin {move}
  case dir of
    n  : rw := rw-1;
    ne : begin rw:=rw-1; cl:=cl+1; end;
    e  : cl := cl+1;
    se : begin rw:=rw+1; cl:=cl+1; end;
    s  : rw := rw+1;
    sw : begin rw:=rw+1; cl:=cl-1; end;
    w  : cl := cl-1;
    nw : begin rw:=rw-1; cl:=cl-1; end;
    end; {case}
end; {move}

begin {Check}
  Match := SearchString[1]=Space[rw,cl];
  i := 1;
  while (i<=length(SearchString)) and Match do begin
    while Space[rw,cl]=' ' do move;
    if SearchString[i] = Space[rw,cl]
    then begin
      move;
      i := i+1;
      end
    else
      Match := false
    end; {while}

  if Match
  then begin
    case dir of
      n  : DirStr := 'N';
      ne : DirStr := 'NE';
      e  : DirStr := 'E';
      se : DirStr := 'SE';
      s  : DirStr := 'S';
      sw : DirStr := 'SW';
      w  : DirStr := 'W';
      nw : DirStr := 'NW';
      end; {case}
    WriteLn(OutputFile, '(', Row:1, ',', Col:1, ') - ', DirStr);
    end; {if}
end {Check};

begin {main program}
  reset(InputFile, 'space.in' );
  rewrite(OutputFile, 'space.out');

  ReadLn(InputFile, SquareSize);
  for Col := 0 to SquareSize+1 do Space[0,Col]:= chr(0);
  for Row := 1 to SquareSize do begin
    Space[Row, 0] := chr(0);
    for Col := 1 to SquareSize do read(InputFile, Space[Row,Col]);
    Space[Row, SquareSize+1] := chr(0);
    ReadLn(InputFile);
    end; {for}
  for Col := 0 to SquareSize+1 do Space[SquareSize+1,Col]:=chr(0);

  while not eof(InputFile) do begin
    ReadLn(InputFile, SearchString);
    WriteLn(OutputFile);
    WriteLn(OutputFile, SearchString);
    Found := False;
    for Row := 1 to SquareSize do
      for Col := 1 to SquareSize do
        for Direction := n to nw do begin
          Check(Row, Col, Direction, CheckResult);
          Found :=  CheckResult or Found;
          end; {for}
    if not Found then WriteLn(OutputFile, 'not found');
    end; {while}
  close(OutputFile);
end.
